#ifndef __WINAMP2_H
#define __WINAMP2_H

#include "player.h"

// implemented
#define WINAMP_REWIND					40044
#define WINAMP_PLAY						40045
#define WINAMP_PAUSE					40046
#define WINAMP_STOP						40047
#define WINAMP_NEXTSONG					40048
#define WINAMP_FILE_PLAY                40029
#define WINAMP_FILE_QUIT                40001
#define WINAMP_FILE_REPEAT              40022
#define WINAMP_FILE_SHUFFLE             40023
#define WINAMP_OPTIONS_AOT              40019
#define WINAMP_RELOAD_SKIN				40291
#define WINAMP_FFWD5S                   40060
#define WINAMP_REW5S                    40061
#define WINAMP_VOLUMEUP                 40058
#define WINAMP_VOLUMEDOWN               40059
#define WINAMP_BUTTON4_SHIFT			40147
#define WINAMP_OPEN_LOC					40155
#define WINAMP_OPTIONS_DSIZE			40165
#define WINAMP_OPTIONS_PREFS			40012
#define WINAMP_FILE_DIR                 40187
#define WINAMP_HIGH_PRIORITY            40025
#define WINAMP_OPTIONS_EQ               40036
#define WINAMP_OPTIONS_ELAPSED          40037
#define WINAMP_OPTIONS_REMAINING        40038
#define WINAMP_OPTIONS_PLEDIT           40040
#define WINAMP_HELP_ABOUT               40041
#define WINAMP_MAINMENU                 40043
#define WINAMP_NEXT_WINDOW              40063
#define WINAMP_OPTIONS_WINDOWSHADE      40064
#define WINAMP_BUTTON1_SHIFT            40144
#define WINAMP_BUTTON2_SHIFT            40145
#define WINAMP_BUTTON3_SHIFT            40146
#define WINAMP_BUTTON5_SHIFT            40148
#define WINAMP_LIST_START             40154
#define WINAMP_BUTTON3_CTRL             40156
#define WINAMP_BUTTON4_CTRL             40157
#define WINAMP_LIST_END             40158
#define IDC_SORT_FILENAME               40166
#define IDC_SORT_FILETITLE              40167
#define IDC_SORT_ENTIREFILENAME         40168
#define IDC_SELECTALL                   40169
#define IDC_SELECTNONE                  40170
#define IDC_SELECTINV                   40171
#define IDM_EQ_LOADPRE                  40172
#define IDM_EQ_LOADMP3                  40173
#define IDM_EQ_LOADDEFAULT              40174
#define IDM_EQ_SAVEPRE                  40175
#define IDM_EQ_SAVEMP3                  40176
#define IDM_EQ_SAVEDEFAULT              40177
#define IDM_EQ_DELPRE                   40178
#define IDM_EQ_DELMP3                   40180
#define IDC_PLAYLIST_PLAY               40184
#define WINAMP_FILE_LOC                 40185
#define WINAMP_OPTIONS_EASYMOVE         40186
#define WINAMP_EDIT_ID3                 40188
#define WINAMP_TOGGLE_AUTOSCROLL        40189
#define WINAMP_VISSETUP                 40190
#define WINAMP_PLGSETUP                 40191
#define WINAMP_VISPLUGIN                40192
#define WINAMP_JUMPTIME                     40193
#define WINAMP_JUMPFILE                 40194
#define WINAMP_JUMP10FWD                40195
#define WINAMP_JUMP10BACK               40197
#define WINAMP_PREVSONG					40198
#define WINAMP_PLAYLIST_WINDOWSHADE 40266
#define WINAMP_MINIBROWSER_TOGGLE 40298
#define WINAMP_OPTIONS_SKINS 40219
#define WINAMP_USER_SETVOLUME 122
#define WINAMP_USER_SETPANNING 123
#define WINAMP_USER_BITRATE 126
#define WINAMP_USER_SONGPOSITION 105
#define WINAMP_USER_SONGSEEK 106
#define WINAMP_USER_RESTART 135
#define WINAMP_USER_STATUS 104

#define WC_WINAMP2 "Winamp v1.x"

// class for handling wa2

class wa2 : public player
{
public:
	wa2();
	~wa2();

	HWND GetPlayerWnd();
	void powerOff();

	void repeat();
	void shuffle();

	void prev();
	void play();
	void pause();
	void stop();
	void next();

	void volumeUp();
	void volumeDown();
	void forward5s();
	void rewind5s();

	void openLoc();
	void loadDir();
	void prefs();

	void onTop();
	void loadFile();

	static int position;

	// specific wa2 commands:
	static void wa2::Bang_StopFade(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_BUTTON4_SHIFT);
	}

	static void wa2::Bang_ReloadSkin(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_RELOAD_SKIN);
	}

	static void wa2::Bang_DoubleSize(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_OPTIONS_DSIZE);
	}

	static void wa2::Bang_TimeElapsed(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_OPTIONS_ELAPSED);
	}

	static void wa2::Bang_TimeRemaining(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_OPTIONS_REMAINING);
	}

	static void wa2::Bang_AddSong(HWND caller, LPCSTR args) {
		char addSong[MAX_LINE_LENGTH];
		strcat(addSong, szAmpPath);
		strcat(addSong, " /ADD ");
		strcat(addSong, args);
		WinExec(addSong, SW_NORMAL);
		strcpy(addSong, "");
	}

	static void wa2::Bang_About(HWND caller, LPCSTR args) {
		SetForegroundWindow(getWA2wnd()); // You have to push the window forward before sending messages to keep it on top.
		sendMsg(WINAMP_HELP_ABOUT);
	}

	static void wa2::Bang_EasyMove(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_OPTIONS_EASYMOVE);
	}

	static void wa2::Bang_Eq(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_OPTIONS_EQ);
	}

	static void wa2::Bang_Jump10Back(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_JUMP10BACK);
	}

	static void wa2::Bang_Jump10Fwd(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_JUMP10FWD);
	}

	static void wa2::Bang_JumpToFile(HWND caller, LPCSTR args) {
		SetForegroundWindow(getWA2wnd());
		sendMsg(WINAMP_JUMPFILE);
	}

	static void wa2::Bang_JumpToTime(HWND caller, LPCSTR args) {
		SetForegroundWindow(getWA2wnd());
		sendMsg(WINAMP_JUMPTIME);
	}

	static void wa2::Bang_ListEnd(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_LIST_END);
	}

	static void wa2::Bang_ListStart(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_LIST_START);
	}

	static void wa2::Bang_MainMenuPopup(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_MAINMENU);
	}

	static void wa2::Bang_Playlist(HWND caller, LPCSTR args) {
		if (!PlaylistNotOpen) {
			if (!getWA2wnd())
				playerOpen();
		}
		sendMsg(WINAMP_OPTIONS_PLEDIT);
	}

	static void wa2::Bang_SelectSkin(HWND caller, LPCSTR args) {
		SetForegroundWindow(getWA2wnd());
		sendMsg(WINAMP_OPTIONS_SKINS);
	}

	static void wa2::Bang_SetPanning(HWND caller, LPCSTR args) {
		SendMessage(getWA2wnd(), WM_USER, (const int)args, WINAMP_USER_SETPANNING);  // Args = 0 - 255, 0 = all_left, 255 = all_right
	}

	static void wa2::Bang_SetVolume(HWND caller, LPCSTR args) {
		SendMessage(getWA2wnd(), WM_USER, (const int)args, WINAMP_USER_SETVOLUME); 
	}

	static void wa2::Bang_ShadeBoth(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_PLAYLIST_WINDOWSHADE);
		sendMsg(WINAMP_OPTIONS_WINDOWSHADE);
	}

	static void wa2::Bang_ShadePlaylist(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_PLAYLIST_WINDOWSHADE);
	}

	static void wa2::Bang_StartPlugin(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_VISPLUGIN);
	}

	static void wa2::Bang_StopPlugin(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_VISPLUGIN);
	}

	static void wa2::Bang_ToggleBrowser(HWND caller, LPCSTR args) {
		SetForegroundWindow(getWA2wnd());
		sendMsg(WINAMP_MINIBROWSER_TOGGLE);
	}

	static void wa2::Bang_VisSetup(HWND caller, LPCSTR args) {
		SetForegroundWindow(getWA2wnd());
		sendMsg(WINAMP_VISSETUP);
	}

	static void wa2::Bang_WindowShade(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_OPTIONS_WINDOWSHADE);
	}

	static void wa2::Bang_Rew(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_REWIND);
	}

	static void wa2::Bang_HighPriority(HWND caller, LPCSTR args) {
		sendMsg(WINAMP_HIGH_PRIORITY);
	}

	static void wa2::Bang_LoadEQPreset(HWND caller, LPCSTR args) {
		SetForegroundWindow(getWA2wnd());
		sendMsg(IDM_EQ_LOADPRE);
	}

	static void wa2::Bang_PlayPause(HWND caller, LPCSTR args) {
		if (!PlayPauseNotOpen) {
			if (!getWA2wnd())
				playerOpen();
		}
		int status = SendMessage(getWA2wnd(), WM_USER, 0, WINAMP_USER_STATUS);
		(status == 1) ? sendMsg(WINAMP_PAUSE) : sendMsg(WINAMP_PLAY);
	}

	static void wa2::Bang_Ffwd10s(HWND caller, LPCSTR args) {
		MovePositive(10);
	}

	static void wa2::Bang_Ffwd20s(HWND caller, LPCSTR args) {
		MovePositive(20);
	}

	static void wa2::Bang_Rew10s(HWND caller, LPCSTR args) {
		MoveNegative(10);
	}

	static void wa2::Bang_Rew20s(HWND caller, LPCSTR args) {
		MoveNegative(20);
	}

	static void wa2::Bang_Restart(HWND caller, LPCSTR args) {
		SendMessage(getWA2wnd(), WM_USER, 0, WINAMP_USER_RESTART);
	}

	static void wa2::Bang_EditID3(HWND caller, LPCSTR args)
	{
		SetForegroundWindow(getWA2wnd());
		sendMsg(WINAMP_EDIT_ID3);
	}

	/*static void wa2::Bang_MovePosition(HWND caller, LPCSTR args) {
		if (args) {
			char* tokens[1]; 
			char modifier[1]; // + or -
			char amount[10]; // amount to change by
			modifier[0] = amount[0] = 0; // nulling the first in the array
			
			tokens[0] = modifier;
			tokens[1] = amount;
			
			LCTokenize(args, tokens, 2, NULL);
			// if modifier is negative send to MoveNegative(), else MovePositive()
			(!strcmp(modifier, "-")) ? MoveNegative((int)amount) : MovePositive((int)amount);
		}
	}*/

	/*void wa2::fileInfo() {
	// Getting the winamp title and removing the "-Winamp" from it
		GetWindowText(getWA2wnd(), song_title, sizeof(song_title));
		p = song_title + strlen(song_title) - 8;
		while (p >= song_title) 
		{
			if (!strnicmp(p, "- Winamp", 8))
				break;
			p--;
		}
		if (p >= song_title)
			p--;
		while (p >= song_title && *p == ' ') 
			p--;
		*++p = 0;
		
		samplerate = SendMessage(getWA2wnd(), WM_USER, 0, WINAMP_USER_BITRATE); // The samplerate of the current song
		bitrate = SendMessage(getWA2wnd(), WM_USER, 1, WINAMP_USER_BITRATE); // The bitrate of the current song
		channels = SendMessage(getWA2wnd(), WM_USER, 2, WINAMP_USER_BITRATE); // The channel status
		
		(channels == 1) ? strcpy(chan, "Mono") : strcpy(chan, "Stereo");
		sprintf(fileProp, "Bitrate: %d kbps\nSampleRate: %d khz\nChannels: %s", bitrate, samplerate, chan);
		MessageBox(GetLitestepWnd(), fileProp, song_title, MB_OK | MB_ICONQUESTION | MB_SETFOREGROUND);
	}*/

	// These are the main processing functions...

	// Moves position backwards
	static void wa2::MoveNegative(int amount) {
		amount *= 1000;
		position = SendMessage(getWA2wnd(), WM_USER, 0, WINAMP_USER_SONGPOSITION);
		SendMessage(getWA2wnd(), WM_USER, position - amount, WINAMP_USER_SONGSEEK);
	}

	// Moves position forwards
	static void wa2::MovePositive(int amount) {
		amount *= 1000;
		position = SendMessage(getWA2wnd(), WM_USER, 0, WINAMP_USER_SONGPOSITION);
		SendMessage(getWA2wnd(), WM_USER, position + amount, WINAMP_USER_SONGSEEK);
	}

	static void wa2::sendMsg(const int msg)
	{
		player::sendMsg(getWA2wnd(), msg);
	}

	static HWND wa2::getWA2wnd()
	{
		return FindWindow(WC_WINAMP2, NULL);
	}

private:
	void wa2Message(const int messages);
	char song_title[MAX_LINE_LENGTH], *p, fileProp[MAX_LINE_LENGTH], chan[7];
	int bitrate, samplerate, channels;
};

#endif